/*
===============================================================================
=== Released under GPL (GNU Public License) ==== No Any Warranty ==============
===============================================================================
*/

#include "../include/common.h"
#include "../include/loader.h"

/* ==== OzEDIT_LoaderLoadFile  =============================================== */
/* first_block MUST BE ALLOCATED !!! */

int OzEDIT_LoaderLoadFile(struct _block *first_block,gchar *filename)
{
 	FILE *f;
 	gchar buffer[512],*block_s,*block_e;
 	gchar current_block[10];
 	guint block,bsize,syntax_err,line,c;

 	struct _block_param temp_block_param,*this_block_param;
 	struct _block temp_block,*this_block;
 
 	f=fopen(filename,"r");
 	if(f==NULL) return ERROR_OPENFILE;
 /* Ora fai un *parse* del file di configurazione */
 	block = 0;
 	syntax_err = 0;
 	line = 0;
 	while(!feof(f))
 	{
 		fgets(buffer,512,f);
  		line++;
/* Elimina eventuali caratteri bianchi o TAB di inzio riga */
  		while(buffer[0]==' ')
  		{
   			for(c=0;c<strlen(buffer);c++) buffer[c]=buffer[c+1];
  		}
  		if(buffer[0] == '!') continue; /* Commento */
  		if(strlen(buffer) < 1) continue; /* Nessun carattere valido */
  		if(strchr(buffer,'!')) 
  		{
   			block_s = (char *)strchr(buffer,'!');
   			*block_s = '\0';
  		}
  		if(((strchr(buffer,'<')) < (strchr(buffer,'>')) && (strchr(buffer,'>') != (char)NULL) && (strchr(buffer,'<') != (char)NULL)))
  /* Inizio o fine di un blocco */
  		{
   			block_s = (char *)strchr(buffer,'<');
   			block_s++;
   			block_e = (char *)strchr(buffer,'>');
   /* Estrai nome del BLOCCO */
   			bsize = (unsigned int)(block_e - block_s);
   			bzero(current_block,10);
   			strncpy(current_block,block_s,bsize);
   			if(current_block[0] != '/')
   			{
    			block = 1;
    			if(first_block == NULL) /* Alloca memoria per il primo blocco */
    			{
     				first_block = (struct _block *)malloc(sizeof(struct _block));
     				if(first_block == NULL)
     				{
      					return ERROR_NOMEM;
     				}
     				this_block = first_block; /* Punta this_block al blocco corrente */     
     				bzero(this_block->name,10); 
     				this_block->next=NULL;
    			}
    			else /* Primo blocco gia` allocato..cerca il prossimo blocco vuoto ! */
    			{
    	 			this_block = first_block; /* Punta this_block al primo blocco */
     				while(this_block->next != NULL) this_block = this_block->next;
     				this_block->next = (struct _block *)malloc(sizeof(struct _block));
     				if(this_block->next == NULL)
     				{
      					return ERROR_NOMEM;
     				}
     				this_block = this_block->next;
     				bzero(this_block->name,10);
     				this_block->next=NULL;    
    			}
    			strncpy(this_block->name,current_block,10); /* Copia nome del blocco */
   			} else {
    			if(block == 0) /* Errore !!! Finisce un blocco non iniziato ?!? */
    			{
     				syntax_err = ERROR_SYNTAX_UNBALANCEDBLOCK;
    			}    
    			bzero(current_block,10);
    			strncpy(current_block,block_s+1,bsize-1);  
    			block = 0;
   			}
  		} else if(block==1) { /* Se non comando inizio blocco e non commento allora parametro */
  		 	bzero(&temp_block_param,sizeof(struct _block_param));
   			block_s = &buffer[0];
   			block_e = (char *)strchr(buffer,' ');
   			bsize = (unsigned int)(block_e - block_s);
   			if(bsize > 10)
   			{
    			syntax_err = ERROR_SYNTAX_VALUETOOBIG;
   			} else {
    			strncpy(temp_block_param.name,buffer,bsize);
   			}
   			if(((strchr(buffer,'"')) < (strrchr(buffer,'"')) && (strchr(buffer,'"') != (char)NULL) && (strrchr(buffer,'"') != (char)NULL)))
   			{
    			block_s = (char *)strchr(buffer,'"');
    			block_s++;
    			block_e = (char *)strrchr(buffer,'"');
    			bsize = (unsigned int)(block_e - block_s);
    			if(bsize < 30)
    			{
     				strncpy(temp_block_param.value,block_s,bsize);
    			} else { /* Errore !!! */
     				syntax_err = ERROR_SYNTAX_VALUETOOBIG;
    			}
/* Aggiungi parametro alla lista parametri del blocco */
    			if(this_block->first_param == NULL) /* Nessun parametro..alloca ! */
    			{
     				this_block->first_param = (struct _block_param *) malloc(sizeof(struct _block_param));
     				if(this_block->first_param == NULL)
     				{
      					return ERROR_NOMEM;
     				}
     				this_block_param=this_block->first_param;
     				bzero(this_block_param->name,10);
     				bzero(this_block_param->value,30);           
     				this_block_param->next = NULL;
    			}
    			else /* Primo parametro gia` allocato...risali e alloca ! */
    			{
     				this_block_param = this_block->first_param;
     				while(this_block_param->next != NULL) this_block_param = this_block_param->next;
     				this_block_param->next = (struct _block_param *)malloc(sizeof(struct _block_param));
     				if(this_block_param->next == NULL)
     				{
      					return ERROR_NOMEM;
     				}
     				this_block_param=this_block_param->next;
     				bzero(this_block_param->name,10);
     				bzero(this_block_param->value,30);           
     				this_block_param->next = NULL;    
    			}
/* ora metti valori del parametro ! */
    			strncpy(this_block_param->name,temp_block_param.name,10);    
    			strncpy(this_block_param->value,temp_block_param.value,30);    
   			} else { /* Errore !!! */
    			syntax_err = ERROR_SYNTAX_NOVALUE;
   			}
  		} else { /* Errore !!! */
   			syntax_err = ERROR_SYNTAX_INVALIDLINE;
  		}
 	}
 	if(syntax_err != 0) { return syntax_err; } else { return ERROR_NOERROR; }
}

/* ============================================================================ */
/* ReturnBlock(first_block, nome) 								*/
/* Ritorna il puntatore al blocco con il nome specificato o NULL se non trovato */
/* ============================================================================ */

struct _block *this_block;
struct _block_param *this_block_param;

struct _block *OzEDIT_LoaderReturnBlock(struct _block *first_block,char *name) 
{
 	if(first_block != NULL) 
 	{
 		this_block = first_block;
  		while(this_block != NULL)
  		{
   			if(strncmp(this_block->name,name,10)==0) return this_block;
   			this_block=this_block->next;
  		}
 	}
 	return NULL;
}

/* ============================================================================ */
/* ReturnBlockParam(first_block,nome blocco,nome parametro)					*/
/* Ritorna il puntatore al parametro del blocco con il nome specificato o NULL  */
/* se non trovato                                                               */
/* ============================================================================ */

struct _block_param *OzEDIT_LoaderReturnBlockParam(struct _block *first_block,char *name,char *parname) 
{
 	if(first_block != NULL) 
 	{
 	 	this_block = first_block;
  		while(this_block != NULL)
  		{
   			if(strncmp(this_block->name,name,10)==0)
   			{
    			this_block_param = this_block->first_param;
     			while(this_block_param != NULL)
    			{
     				if(strncmp(this_block_param->name,parname,10)==0) {
      					return (struct _block_param *)this_block_param;
     				}
     				this_block_param=this_block_param->next;
    			}
   			}
   			this_block=this_block->next; /* Maledetto BUGGG !!!!! */
  		}
 	}
 	return NULL;
}

/* ============================================================================ */
/* ReturnBlockValue(first_block,nome blocco,nome parametro)							*/
/* Ritorna il puntatore al valore del blocco con il nome specificato o NULL  	*/
/* se non trovato                                                               */
/* ============================================================================ */

char *OzEDIT_LoaderReturnBlockValue(struct _block *first_block,char *blockname,char *parname)
{
	struct _block_param *temp_block_param;
 	
	temp_block_param = OzEDIT_LoaderReturnBlockParam(first_block,blockname,parname);
	if(temp_block_param != NULL) {
		return temp_block_param->value;
	} else {
		return NULL;
	}
}

